#ifndef Config_h
#define Config_h

#include <SD.h>

class Config{

  public:
    static void init( String fileName );
    static void load();
    static void save();
    static void dump();
    
    static unsigned char SCROLL_WIDTH;
    static unsigned char LIST_SIZE;
    static unsigned long INITIAL_FREQUENCY;
    static unsigned char BRIGHTNESS;
    static unsigned long REQUEST_INTERVAL;
    static unsigned long RESTART_DELAY;
    static unsigned char CONTROLLER_ADDR;
    static unsigned char CIV_ADDR;
    static bool INVERT_KOPPLER_OUTPUT_C;
    static bool INVERT_KOPPLER_OUTPUT_L;
    static bool INVERT_KOPPLER_OUTPUT_IO;
    static int STEP_LC_INITIAL_VALUE;
    static byte STEP_BIT_WIDTH_C;
    static byte STEP_BIT_WIDTH_L;
    static float STEP_C_MIN_VALUE; 
    static float STEP_L_MIN_VALUE; 
    static int STEP_FREQUENCY_INITIAL_VALUE;
    static byte PIN_ONEWIRE;
    static String DATE;
    static String VERSION;
    static String FILENAME_FREQ;
    static String FILENAME_CONFIG;
    static byte CHIP_SELECT_PIN;
    static byte IC1[];
    static byte IC2[];
    static byte IC3[];
    static unsigned long Config::SERIAL_SPEED_SERIAL1;
    static unsigned long Config::SERIAL_SPEED_SERIAL2;
    static unsigned long Config::SERIAL_SPEED_SERIAL3;
    static String NAME_PAGE_SPLASH;
    static String NAME_PAGE_WAIT;
    static String NAME_PAGE_AUTO_LEFT;
    static String NAME_PAGE_AUTO_RIGHT;
    static String NAME_PAGE_FREQ_LEFT;
    static String NAME_PAGE_FREQ_RIGHT;
    static String NAME_PAGE_MAN_C_LEFT;
    static String NAME_PAGE_MAN_C_RIGHT;
    static String NAME_PAGE_SETUP;
    static String NAME_PAGE_KEYBOARD;

    static unsigned char KEY_CAPACITANCE_UP;
    static unsigned char KEY_CAPACITANCE_DOWN;
    static unsigned char KEY_INDUCTANCE_UP;
    static unsigned char KEY_INDUCTANCE_DOWN;
    static unsigned char KEY_SWITCH_CAP_TRX;
    static unsigned char KEY_STEP;
    static unsigned char KEY_SWITCH_CAP_ANT;
    static unsigned char KEY_FREQUENCY_UP;
    static unsigned char KEY_FREQUENCY_DOWN;
    static unsigned char KEY_FREQUENCY_STEP;
    static unsigned char KEY_AUTO;
    static unsigned char KEY_MAN1;
    static unsigned char KEY_MAN2;
    static unsigned char KEY_STORE;
    static unsigned char KEY_SETUP;
    static unsigned char KEY_SSTORE;
    static unsigned char KEY_EXIT;
    static unsigned char KEY_SNEXT;
    static unsigned char KEY_SPREV;
    static unsigned char KEY_RESET;
    static unsigned char KEY_EDIT0;
    static unsigned char KEY_EDIT1;
    static unsigned char KEY_EDIT2;
    static unsigned char KEY_EDIT3;
    static unsigned char KEY_EDIT4;
    static unsigned char KEY_EDIT5;
    static unsigned char KEY_SEXIT;
    static unsigned char KEY_A;
    static unsigned char KEY_B;
    static unsigned char KEY_C;
    static unsigned char KEY_D;
    static unsigned char KEY_E;
    static unsigned char KEY_F;
    static unsigned char KEY_0;
    static unsigned char KEY_1;
    static unsigned char KEY_2;
    static unsigned char KEY_3;
    static unsigned char KEY_4;
    static unsigned char KEY_5;
    static unsigned char KEY_6;
    static unsigned char KEY_7;
    static unsigned char KEY_8;
    static unsigned char KEY_9;
    static unsigned char KEY_SPACE;
    static unsigned char KEY_BACK;

    static String getPart(String cmd, unsigned char part);
    static int hex2Byte(String hex);

    static int getConfigSize();
    static String *getConfigLabels();
    static String *getConfigValues();
    static bool setConfigValue(String label, String value);

    static unsigned char hexToChar(String byte);
    static byte toAddr1(String value);
    static bool     toBool(String value);
    static unsigned long toRange(String value, unsigned long min = 0, unsigned long max = 1000000000);

  private:    
    static String fileName;
    static char csvLineBreak;
    Config();

};

#endif