#ifndef Display_h
#define Display_h

class Display {

  public:
    Display();
    void main();
    void showPage( String name);
    void writeL(int value);
    void writeC(int value);
    void writeDate(String value);
    void writeVersion(String value);
    void writeLog(String value);
    void writeFrequencyRounded(unsigned long value);
    void writeFrequency(unsigned long value);
    void writeStepFrequency(unsigned long value);
    void writeStep(unsigned long value);
    void writeState();
    void writeEditValue();
    void send(String cmd);
    bool pressed(unsigned char key);
    void startWaitPage();
    void endWaitPage();
    void dim(unsigned char value);
    void showConfig(bool reset = true);
    void configNext();
    void configPrev();
    void isTransceiverConected(bool value);
    void keyboardLoop();
    void showKeyboard(int index);
    void redrawConfig();

  private:
    String editValue;
    bool _isTransceiverConnected;
    unsigned char scrollPosition;
    String returnPage;
    String currentPage;
    int qtyPressedKeys;
    unsigned char pressedKeys[32];
    unsigned char editIndex;
    bool _isTransceiverConnectedLast;

    int l;
    int c;
    unsigned long frequency;
    unsigned long frequencyRounded;
    int stepFrequency;
    int step;

    void resetKeys();
    void readDisplay();
};

#endif
