#ifndef Koppler_h
#define Koppler_h

#include "LookupTable.h"
#include <OneWire.h>

class Koppler{

  public:
    OneWire net;
    Koppler();
    void main();
    void setC(int value);
    int  getC();
    void setL(int value);
    int getL();
    void setIO(unsigned char value);
    unsigned char getIO();
    void setLookupTable(LookupTable value);
    byte getIC1();
    byte getIC2();
    byte getIC3();

  private:
    bool initialized;
    bool valide;
    void invalidate();


    void writeBus(unsigned char*,unsigned char);
    void ic1();
    void ic2();
    void ic3();

    int c;
    int l;
    // position of capacitance 0=off, 1=ANT, 2=TRX
    unsigned char io = 0;

    // Transfervariable for DS2408 1-Wire 8-Channel Addressable Switch
    unsigned char _a = 0;
    unsigned char _lastA = 0;
    // Transfervariable for DS2408 1-Wire 8-Channel Addressable Switch
    unsigned char _b = 0;
    unsigned char _lastB = 0;
    // Transfervariable for DS2408 1-Wire 8-Channel Addressable Switch
    unsigned char _c = 0;
    unsigned char _lastC= 0;


};

#endif