#ifndef Transceiver_h
#define Transceiver_h

class Transceiver {

  public:

    // @param addr           The address of the arduino.
    // @parma deviceAddr     The address of the transceiver
    Transceiver(int ctrlAddr, int civAddr);

    // The main loop of the transceiver module.
    void main();

    void setMode(unsigned char value);
    unsigned char getMode();

    void setFrequency( unsigned long value);
    unsigned long getFrequency();
    
    unsigned long getFrequencyRounded();
    bool hasFrequencyChanged();
    
    void requestFrequency();
    bool comesFrequencyFromTRX();
    bool isConnected();
    void setRequestInterval(unsigned long interval);
    unsigned long lastReceived;
    void restartRequest();
    unsigned long getRequestInterval();
    
    // Address of the arduino on the serial bus
    int ctrlAddress;
    // Address of the actual transceiver on the serial bus. 
    int civAddress;
        
  private:

    //
    bool isRequestRequired;

    //
    unsigned long requestInterval;

    //
    unsigned long myRequestInterval;

    // Frequency read from device
    unsigned long frequency;
    unsigned long nextFrequency;
    
    unsigned long lastInterval;
    void readTransceiver();
    bool frequencyFromTRX;
};

#endif